//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


#pragma once
#include "uploadlistctrl.h"
#include "ResizableLib\ResizableDialog.h"
#include "SplitterControl.h"
#include "queuelistctrl.h"
#include "clientlistctrl.h"
#include "BtnST.h"

#define COLLAPSE_ONLY	0
#define EXPAND_ONLY		1
#define EXPAND_COLLAPSE	2
// CTransferWnd dialog

class CUploadWnd : public CResizableDialog
{
	DECLARE_DYNAMIC(CUploadWnd)

public:
	CUploadWnd(CWnd* pParent = NULL);   // standard constructor
	virtual ~CUploadWnd();
	void	ShowQueueCount(uint32 number);
	void	SwitchUploadList();
	void	UpdateListCount(uint8 listindex);
	void	OnBnClickedQueueRefreshButton();
	void	Localize();
	void	UpdateCatTabTitles();

	bool 	isUploadQueueVisible() { return (windowtransferstate == 0); }
	bool	toplistactive;

	// Dialog Data
	enum { IDD = IDD_TRANSFER };
	CUploadListCtrl			uploadlistctrl;
	CQueueListCtrl			queuelistctrl;
	CClientListCtrl			clientlistctrl;
	CToolTipCtrl			m_ttip;
protected:
	void DoResize(int delta);
	void UpdateSplitterRange();
	void SetInitLayout();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	virtual LRESULT DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	afx_msg BOOL OnToolTipNotify(UINT id, NMHDR *pNMH, LRESULT *pResult);
	void DoSplitResize(int delta);
	CSplitterControl m_wndSplitter;
	
	DECLARE_MESSAGE_MAP()

private:
	CString m_strToolTip;
	int m_iOldToolTipItemDown;
	int m_iOldToolTipItemUp;
	int m_iOldToolTipItemQueue;
	int m_iOldToolTipItemDowning;
	int m_iOldToolTipItemConnect;
	uint8	windowtransferstate;
	CButtonST	m_uplBtn;
	int	rightclickindex;
	void UpdateToolTips(void);
	int GetItemUnderMouse(CListCtrl* ctrl);
	CToolTipCtrl* tooltip;

	int m_nDragIndex;
	int m_nDropIndex;
	int m_nLastCatTT;
	bool m_bIsDragging;
	CImageList* m_pDragImage;
	HICON icon_upload;
	POINT	m_pLastMousePoint;

public:
	afx_msg void OnHoverTopList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnHoverBottomList(NMHDR *pNMHDR, LRESULT *pResult);
	void OnMouseMove(UINT nFlags, CPoint point);
	void OnLButtonUp(UINT nFlags, CPoint point);
	virtual BOOL OnCommand(WPARAM wParam,LPARAM lParam );
};
